%define kdir %(realpath /usr/include/linux-2.6.*-std26-up)

Name: pcmcia-cs
Version: 3.2.8
Release: alt7

Summary: PCMCIA daemon and utilities
Group: System/Kernel and hardware
License: GPL
Url: http://pcmcia-cs.sourceforge.net/

Source: ftp://projects.sourceforge.net/pub/%name/%name-%version.tar.gz
Source2: pcmcia.conf
Source3: pcmcia-cs-3.1.24-isdn.script
Source7: pcmcia-modules.config
Source8: GLOBETROTTER.dat
Source9: pcmcia-apm

Patch0: %name-3.1.23-makefile.patch
Patch3: %name-3.2.3-install.patch
Patch4: %name-3.1.24-manfix.patch
Patch7: %name-3.2.7-cardmgr-openlog-daemonize-fix.patch
Patch8: %name-3.1.18-script.patch
Patch12: %name-3.1.24-wireless.patch
Patch13: %name-3.1.27-makefile.patch
Patch15: %name-3.1.31-fixbuild.patch
Patch17: %name-3.1.31-umask.patch
Patch18: %name-3.1.31-nobinutils.patch
Patch20: %name-3.2.5-no-modversions.patch
Patch25: %name-3.2.8-alt-ifindex.patch
Patch26: %name-3.2.8-alt-initscript.patch
Patch27: %name-3.2.8-alt-config_opts.patch
Patch28: %name-3.2.8-alt-config.patch
Patch29: %name-3.2.8-alt-netstrip.patch
Patch30: %name-3.2.8-cardinfo.patch
Patch31: %name-3.2.8-alt-ide_memory.patch

Patch101: %name-3.2.3-alt-Xext.patch

PreReq: chkconfig modutils > 2.4.25-alt2
Requires: libnetlink network-config-subsystem powermgmt-base
Obsoletes: kernel-%name
Provides: kernel-%name

BuildPreReq: kernel-headers-std26-up libnetlink-devel
%if_with x11
BuildRequires: xorg-x11-devel xorg-x11-libs glib-devel gtk+2-devel libxforms-devel
%endif

%description
Many laptop machines (and some non-laptops) support PCMCIA cards for
expansion. Also known as "credit card adapters," PCMCIA cards are small
cards for everything from SCSI support to modems. PCMCIA cards are hot
swappable (i.e., they can be exchanged without rebooting the system) and
quite convenient to use. The %name package contains a card manager daemon
that can respond to card insertion and removal events by loading and
unloading drivers on demand.  The daemon also supports hot swapping,
so that the cards can be safely inserted and ejected at any time.

%package X11
Summary: PCMCIA daemon and utilities X11R6 part
Group: System/Kernel and hardware
Requires: %name = %version-%release

%description X11
Many laptop machines (and some non-laptops) support PCMCIA cards for
expansion. Also known as "credit card adapters," PCMCIA cards are small
cards for everything from SCSI support to modems. PCMCIA cards are hot
swappable (i.e., they can be exchanged without rebooting the system) and
quite convenient to use. The %name package contains a card manager daemon
that can respond to card insertion and removal events by loading and
unloading drivers on demand.  The daemon also supports hot swapping,
so that the cards can be safely inserted and ejected at any time.

%prep
%setup -q
%patch0 -p1
%patch3 -p1
%patch4 -p1
%patch7 -p1
%patch8 -p1
%patch12 -p1
%patch13 -p1
%patch15 -p1
%patch17 -p1
%patch18 -p1
%patch20 -p1
%patch25 -p1
%patch26 -p1
%patch27 -p1
%patch28 -p1
%patch29 -p1
%patch30 -p1
%patch31 -p1

%patch101 -p1

chmod -R +w .

%build

%__cat > include/pcmcia/autoconf.h << EOF
#define LINUX "%kdir"
#define PREFIX ""
#define KCC "cc"
#define UCC "cc"
#define LD "ld"
#define KFLAGS ""
#define UFLAGS ""
#define PCDEBUG ""
#define USE_PM 1
#define UNSAFE_TOOLS 1
#define CONFIG_CARDBUS 1
#define CONFIG_PNP_BIOS 1
#define UTS_RELEASE "2.6.11"
#define UTS_VERSION "unknown"
#define LINUX_VERSION_CODE 132619
#define KERNEL_VERSION(a,b,c) (((a) << 16) + ((b) << 8) + (c))

#define MODDIR "/lib/modules/2.6.11-std26-up-alt5"

/* Options from /usr/include/linux-2.6.11-std26-up/.config */
#define CONFIG_MODULES 1
#define CONFIG_PCMCIA 1
#undef  CONFIG_SMP
#define CONFIG_PREEMPT 1
#undef  CONFIG_RTHAL
#define CONFIG_HIGHMEM 1
#define CONFIG_PCI 1
#define CONFIG_PM 1
#define CONFIG_SCSI 1
#undef  CONFIG_IEEE1394
#define CONFIG_INET 1
#define CONFIG_NET_PCMCIA_RADIO 1
#define CONFIG_TR 1
#undef  CONFIG_NET_FASTROUTE
#define CONFIG_NET_DIVERT 1
#define CONFIG_MODVERSIONS 1
#define CONFIG_DEBUG_KERNEL 1
#undef  CONFIG_MEMLEAK
#undef  CONFIG_DEBUG_SPINLOCK
#define CONFIG_PROC_FS 1
#define CONFIG_X86_L1_CACHE_BYTES 32
#define CONFIG_X86_L1_CACHE_SHIFT 5
#define CONFIG_PCI_QUIRKS 1
#undef  CONFIG_EISA
#define CONFIG_X86_CMPXCHG 1
#undef  CONFIG_X86_PAE
#undef  CONFIG_RWSEM_GENERIC_SPINLOCK
#define CONFIG_RWSEM_XCHGADD_ALGORITHM 1
#define ARCH "i386"
#define HOST_ARCH "i386"
#define AFLAGS ""
#define CONFIG_ISA 1
#define CONFIG_UID16 1

#define HAS_PROC_BUS 1
#undef  NEW_AIC7XXX
#define AIC7XXX_H <../drivers/scsi/aic7xxx/aic7xxx_osm.h>
#define SYSV_INIT 1
#define RC_DIR "/etc/rc.d"
#undef HAS_FORMS
%if_with x11
#define HAS_XAW 1
#define HAS_GTK 1
#define GTK_CFLAGS "-DXTHREADS -D_REENTRANT -DXUSE_MTSAFE_API -I/usr/include/gtk-2.0 -I/usr/lib/gtk-2.0/include -I/usr/X11R6/include -I/usr/include/atk-1.0 -I/usr/include/pango-1.0 -I/usr/include/freetype2 -I/usr/include/freetype2/config -I/usr/include/glib-2.0 -I/usr/lib/glib-2.0/include"
#define GTK_LIBS "-lgtk-x11-2.0"
#define XMANDIR "/usr/X11R6/man/"
%else
#undef HAS_FORMS
#undef HAS_XAW
#undef HAS_GTK
#undef GTK_CFLAGS
#undef GTK_LIBS
#undef XMANDIR
%endif
#define HAS_WORDEXP 1
#define MANDIR "/usr/share/man/"

EOF

%__cat > config.mk << EOF
LINUX=%kdir
PREFIX=
KCC=cc
UCC=cc
LD=ld
KFLAGS=
UFLAGS=
PCDEBUG=
USE_PM=y
UNSAFE_TOOLS=y
CONFIG_CARDBUS=y
CONFIG_PNP_BIOS=y
UTS_RELEASE=2.6.11
UTS_VERSION=unknown
LINUX_VERSION_CODE=132619

MODDIR=/lib/modules/2.6.11-std26-up-alt5

# Options from /usr/include/linux-2.6.11-std26-up/.config
CONFIG_PCMCIA=y
# CONFIG_SMP is not defined
CONFIG_PREEMPT=y
# CONFIG_RTHAL is not defined
CONFIG_HIGHMEM=y
CONFIG_PCI=y
CONFIG_PM=y
CONFIG_SCSI=y
# CONFIG_IEEE1394 is not defined
CONFIG_INET=y
CONFIG_NET_PCMCIA_RADIO=y
CONFIG_TR=y
# CONFIG_NET_FASTROUTE is not defined
CONFIG_NET_DIVERT=y
CONFIG_MODVERSIONS=y
CONFIG_DEBUG_KERNEL=y
# CONFIG_MEMLEAK is not defined
# CONFIG_DEBUG_SPINLOCK is not defined
CONFIG_PROC_FS=y
CONFIG_X86_L1_CACHE_BYTES=32
CONFIG_X86_L1_CACHE_SHIFT=5
CONFIG_PCI_QUIRKS=y
# CONFIG_EISA is not defined
CONFIG_X86_CMPXCHG=y
# CONFIG_X86_PAE is not defined
# CONFIG_RWSEM_GENERIC_SPINLOCK is not defined
CONFIG_RWSEM_XCHGADD_ALGORITHM=y
ARCH=i386
HOST_ARCH=i386
AFLAGS=
CONFIG_ISA=y
CONFIG_UID16=y

CPPFLAGS=-I../include/static -I$(LINUX)/include -I../include
WFLAG=-Wa,--no-warn
HAS_PROC_BUS=y
DO_IDE=y
DO_PARPORT=y
DO_ORINOCO=y
# NEW_AIC7XXX is not defined
SYSV_INIT=y
RC_DIR=/etc/rc.d
%if_with x11
HAS_FORMS=y
HAS_XAW=y
HAS_GTK=y
GTK_CFLAGS=-DXTHREADS -D_REENTRANT -DXUSE_MTSAFE_API -I/usr/include/gtk-2.0 -I/usr/lib/gtk-2.0/include -I/usr/X11R6/include -I/usr/include/atk-1.0 -I/usr/include/pango-1.0 -I/usr/include/freetype2 -I/usr/include/freetype2/config -I/usr/include/glib-2.0 -I/usr/lib/glib-2.0/include
GTK_LIBS=-lgtk-x11-2.0
XMANDIR=/usr/X11R6/man/
%else
# HAS_FORMS is not defined
# HAS_XAW is not defined
# HAS_GTK is not defined
# GTK_CFLAGS is not defined
# GTK_LIBS is not defined
# XMANDIR is not defined
%endif
HAS_WORDEXP=y
MANDIR=/usr/share/man/

EOF

make CFLAGS="$RPM_OPT_FLAGS -O3 -Wall -Wstrict-prototypes -Wa,--no-warn" all

%make_build all DIRS='$(UDIRS)' CC=gcc CFLAGS="$RPM_OPT_FLAGS"

%install
%__mkdir_p %buildroot{/usr/bin,/sbin,%_mandir/man8,%_initdir}
%make_install install DIRS='$(UDIRS)' PREFIX=%buildroot MANDIR=%buildroot%_mandir
chmod 755 %buildroot/sbin/*

%__install -m644 %SOURCE8 %buildroot%_sysconfdir/pcmcia/cis/
%__install -p -m644 -D %SOURCE7 %buildroot%_sysconfdir/modutils.d/pcmcia

%__mkdir_p %buildroot%_sysconfdir/apm/scripts.d
%__mkdir_p %buildroot%_sysconfdir/apm/resume.d
%__mkdir_p %buildroot%_sysconfdir/apm/suspend.d
%__install -m755 %SOURCE9 %buildroot%_sysconfdir/apm/scripts.d/pcmcia
%__ln_s ../scripts.d/pcmcia %buildroot%_sysconfdir/apm/resume.d/65pcmcia
%__ln_s ../scripts.d/pcmcia %buildroot%_sysconfdir/apm/suspend.d/70pcmcia

# We need our own default %_sysconfdir/sysconfig/pcmcia script.
install -p -m755 -D %SOURCE2 %buildroot%_sysconfdir/sysconfig/pcmcia
install -m755 debug-tools/lspnp %buildroot%_bindir/
install -m755 debug-tools/setpnp %buildroot%_bindir/

install -m755 %SOURCE3 %buildroot%_sysconfdir/pcmcia/isdn
chmod 0644 %buildroot%_sysconfdir/pcmcia/config
chmod 0644 %buildroot%_sysconfdir/sysconfig/pcmcia

find %buildroot%_mandir -type f -print0 |
	xargs -r0 chmod 644

%post
%post_service pcmcia

%preun
%preun_service pcmcia

%files
/sbin/*
%_mandir/man?/*
%config(noreplace) %_initdir/pcmcia
%config(noreplace) %_sysconfdir/sysconfig/*
%dir %_sysconfdir/pcmcia
%config(noreplace) %_sysconfdir/pcmcia/*
%config(noreplace) %_sysconfdir/modutils.d/pcmcia
%_sysconfdir/apm/*/*pcmcia
%dir %_localstatedir/pcmcia
%_datadir/pnp.ids
%doc CHANGES COPYING README SUPPORTED.CARDS doc/PCMCIA-{HOWTO,PROG}

%if_with x11
%files X11
%_x11bindir/*
%_x11mandir/man?/*
%_bindir/*
%endif

%changelog
* Mon Jul 04 2005 Valery Inozemtsev <shrek@altlinux.ru> 3.2.8-alt7
- fixed #7224

* Sat Jun 25 2005 Valery Inozemtsev <shrek@altlinux.ru> 3.2.8-alt6
- added support Hawking 56K V.90 Fax Modem PC Card
- fixed BuildRequires
- fixed bug in initscript

* Mon Jun 20 2005 Valery Inozemtsev <shrek@altlinux.ru> 3.2.8-alt5
- fixed #4915, #5044
- build with kernel-headers-std26-up
- not build X11 subpackage

* Thu Mar 17 2005 Valery Inozemtsev <shrek@altlinux.ru> 3.2.8-alt4
- initscript: fixed regression introduced by previous change

* Wed Mar 16 2005 Valery Inozemtsev <shrek@altlinux.ru> 3.2.8-alt3
- fixed initscript for kernel-2.6.11
- fixed modutils config
- remove old patches

* Mon Feb 07 2005 Denis Ovsienko <pilot@altlinux.ru> 3.2.8-alt2
- fixed ifindex patch (warnings and libnetlink cache)
- stripped off interface configuration code

* Sun Jan 16 2005 Valery Inozemtsev <shrek@altlinux.ru> 3.2.8-alt1
- 3.2.8
- added reserve irq5

* Thu Jan 13 2005 Valery Inozemtsev <shrek@altlinux.ru> 3.2.7-alt9
- added kernel 2.6-specifix fixes for initscript (#5873)

* Fri Dec 17 2004 Denis Ovsienko <pilot@altlinux.ru> 3.2.7-alt8
- CONFMETHOD moves to /etc/sysconfig/network (network-config-subsystem)

* Sat Dec 04 2004 Denis Ovsienko <pilot@altlinux.ru> 3.2.7-alt7
- added explicit network-config-subsystem dependency

* Sun Nov 07 2004 Denis Ovsienko <pilot@altlinux.ru> 3.2.7-alt6
- Rewritten pcmcia-cs-3.1.28-network-script-fix.patch for /etc/net support

* Thu Sep 16 2004 Denis Ovsienko <pilot@altlinux.ru> 3.2.7-alt5
- new ifindex patch (#5159)

* Tue Jul 20 2004 Anton Farygin <rider@altlinux.ru> 3.2.7-alt4
- fixed #4562 (lspnp, setpnp tools added)
- added Agere  Systems Wireless PC Card Model 0104 (#4824)

* Tue Jun 29 2004 Anton Farygin <rider@altlinux.ru> 3.2.7-alt3
- updated config (#4188)

* Fri May 14 2004 Anton Farygin <rider@altlinux.ru> 3.2.7-alt2
- replaced module wlan_cs to orinoco_cs (#2836)

* Fri Apr 30 2004 Anton Farygin <rider@altlinux.ru> 3.2.7-alt1
- new version
- added kernel 2.6-specifix fixes for initscript

* Tue Aug 12 2003 Rider <rider@altlinux.ru> 3.2.4-alt1
- new version
- include file /etc/modutils.d/pcmcia
- Requires modutils > 2.4.25-alt2

* Thu Jan 09 2003 Konstantin Volckov <goldhead@altlinux.ru> 3.2.3-alt2
- Fixed post scripts

* Thu Nov 28 2002 Konstantin Volckov <goldhead@altlinux.ru> 3.2.3-alt1
- 3.2.3
- Fixed some patches
- Fixed permissions
- Fixed buildrequires
- Added new subpackage X11 with XFree86 utilities

* Tue Sep 24 2002 Stanislav Ievlev <inger@altlinux.ru> 3.1.31-alt5
- rebuild with new Xforms (added patch100 to fix build)
- added Packager tag.
- rebuild with new XFree (added patch101 to fix build)

* Wed Jun 19 2002 Konstantin Volckov <goldhead@altlinux.ru> 3.1.31-alt4
- Fixed spec exit bug

* Fri Jun 14 2002 Konstantin Volckov <goldhead@altlinux.ru> 3.1.31-alt3
- Fixed kudzu detection
- Fixed BUG in include_ports (removed #14 patch)
- Changed insmod to modprobe first
- Removed %post & %preun services

* Tue May 21 2002 Konstantin Volckov <goldhead@altlinux.ru> 3.1.31-alt2
- Fixed bug in initscript

* Tue May 21 2002 Konstantin Volckov <goldhead@altlinux.ru> 3.1.31-alt1
- 3.1.31
- Removed requires to binutils

* Tue Sep 04 2001 Dmitry V. Levin <ldv@altlinux.ru> 3.1.28-alt2
- Fixed network startup script (rider).
- Fixed /sbin/cardmgr to not spam on console.
- Fixed /sbin/cardmgr to daemonize correctly.
- Fixed manpage permissions.
- Updated startup script.

* Wed Aug 15 2001 Dmitry V. Levin <ldv@altlinux.ru> 3.1.28-alt1
- 3.1.28

* Tue Mar 20 2001 Dmitry V. Levin <ldv@altlinux.ru> 3.1.25-ipl2
- Use default %_sysconfdir/pcmcia/network.

* Sat Mar 10 2001 Dmitry V. Levin <ldv@fandra.org> 3.1.25-ipl1
- 3.1.25

* Wed Feb 07 2001 Dmitry V. Levin <ldv@fandra.org> 3.1.24-ipl2
- Fixed fmvj18x_cs manpage.

* Sun Jan 21 2001 Dmitry V. Levin <ldv@fandra.org> 3.1.24-ipl1
- 3.1.24

* Thu Dec 21 2000 Dmitry V. Levin <ldv@fandra.org> 3.1.23-ipl1mdk
- Initial revision.
